
var APP_TOKEN = "12345678901234567890";
var CUSTOM_URL_SCHEME = "easyappear";

var WEBSERVICE_ROOT = "https://app.easyappear.it/webservice/";

var APP_VERSIONE_REMOTA = "0.0";
var APP_VERSIONE_REMOTA_LITE = "0.0";

var FS = 0;
var DIRECTORY = 0;
var APP_PATH = "";

var APP_JSON = '{"APP_TOKEN":"'+APP_TOKEN+'","CUSTOM_URL_SCHEME":"'+CUSTOM_URL_SCHEME+'"}';

var MODALITA_DEBUG = true;

//window.onerror = javascriptErrorHandler;
document.addEventListener('deviceready', onDeviceReady, false);

function onDeviceReady() {  
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, 
        function (fs) {
            FS = fs;
            FS.root.getDirectory(".easyappear", {create: true}, 
                function(directory) {
                    //iCloud: No Backup
                    //directory.setMetadata(onSetMetadataWin, onSetMetadataFail, {"com.apple.MobileBackup": 1});
                    DIRECTORY = directory;  
                    APP_PATH = DIRECTORY.nativeURL + "/";
                    
                    DIRECTORY.getDirectory("webapp", {create: true}, 
                        function(directory) {
                            file_scrivi(
                                "webapp/app.json", APP_JSON, 
                                function() {
                                    if(controlla_connessione()) {
                                        ajax(
                                            WEBSERVICE_ROOT+"../webapp/app_version.txt"+noCache(),
                                            true,
                                            function(contenuto1){
                                                APP_VERSIONE_REMOTA = contenuto1;
                                                file_leggi(
                                                    "webapp/app_version.txt",
                                                    function(contenuto2) {
                                                        if(APP_VERSIONE_REMOTA != contenuto2) {
                                                            file_download(
                                                                WEBSERVICE_ROOT+"app_zip.php",
                                                                "app_zip.zip",
                                                                function(contenuto3){
                                                                    extractZip(
                                                                        contenuto3.nativeURL, 
                                                                        APP_PATH+"webapp/", 
                                                                        function() {
                                                                            document.getElementById('loader_progress').style.height = "0px";
                                                                            document.getElementById('loader_progress').style.visibility = "hidden";
                                                                            document.getElementById('loader_progress_cursore').style.height = "0px";
                                                                            document.getElementById('loader_progress_label').innerHTML = 'caricamento APP..';

                                                                            alert("esegui script install");
                                                                        }, 
                                                                        function() {
                                                                            alert("errore: extractZip");
                                                                        }
                                                                    );
                                                                }, 
                                                                function() {}
                                                            );
                                                        }else{
                                                            //alert("debug (lib.js): 83");
                                                            setTimeout(
                                                                function() {
                                                                    window.open(APP_PATH+"webapp/index.html"+noCache(),"_self");
                                                                },
                                                                500
                                                            );
                                                        }
                                                    },
                                                    function(valore) {
                                                        
                                                        if(JSON.stringify(valore) == '{"code":1}') {
                                                            alert(WEBSERVICE_ROOT+"app_zip.php");
                                                            file_download(
                                                                WEBSERVICE_ROOT+"app_zip.php",
                                                                "app_zip.zip",
                                                                function(valore) {
                                                                    // extractZip(
                                                                    //     valore.nativeURL, 
                                                                    //     APP_PATH+"webapp/", 
                                                                    //     function() {
                                                                    //         document.getElementById('loader_progress').style.height = "0px";
                                                                    //         document.getElementById('loader_progress').style.visibility = "hidden";
                                                                    //         document.getElementById('loader_progress_cursore').style.height = "0px";
                                                                    //         document.getElementById('loader_progress_label').innerHTML = 'caricamento APP..';

                                                                    //         alert("esegui script install");
                                                                    //     }, 
                                                                    //     function() {
                                                                    //         alert("errore: extractZip");
                                                                    //     }
                                                                    // );
                                                                }, 
                                                                function() {}                                                               }
                                                            );
                                                        }else{
                                                            //alert"app_version_controlla_locale_fail: aggiornamento inutile");
                                                            setTimeout(
                                                                function() {
                                                                    window.open(APP_PATH+"webapp/index.html"+noCache(),"_self");
                                                                },
                                                                500
                                                            );
                                                        }
                                                    }
                                                );
                                            }
                                            ,function() {
                                                alert("ajax errore");
                                            }
                                        );
                                    }else{
                                        setTimeout(
                                            function() {
                                                window.open(APP_PATH+"webapp/index.html"+noCache(),"_self");
                                            },
                                            500
                                        );  
                                    }
                                }, 
                                function(errore) {
                                    alert(" app.json errore scrittura\n"+JSON.stringify(errore));
                                }
                            );
                        }
                    );
                }
            );
        }
    );
}

//**************************************************************************************************
//FUNCTIONS ****************************************************************************************
//**************************************************************************************************

function ajax(nomeFile, asinc, callback_success, callback_fail, metodo) {
    //alert("debug: ajax\n"+nomeFile);
    if(!callback_success)callback_success = success;
    if(!callback_fail)callback_fail = fail;
    
    var xmlHttp, contenuto;
    
    if(!asinc)asinc=false;
    if(!metodo)metodo="GET";
    
    if(window.ActiveXObject) {
        xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    }else if(window.XMLHttpRequest) {
        xmlHttp = new XMLHttpRequest();
    }
    
    xmlHttp.onreadystatechange = function() {
        if(xmlHttp.readyState == 4) {
            if(xmlHttp.status == 200) {
                contenuto = xmlHttp.responseText;
                execJS(contenuto);
                if(asinc) {
                    callback_success(contenuto);
                }
            }else{
                if(asinc) {
                    callback_fail();
                }
            }
        }
    }
    
    xmlHttp.open(metodo,nomeFile,asinc);
    xmlHttp.send(null);
    
    return contenuto;
  
}

function execJS(t) {
    var p1 = 0, p2 = 0, p3 = 0, p4 = 0;
    p1 = t.indexOf("<" + "script", 0);
    if(p1 == -1) return t;
    
    p2 = t.indexOf(">", p1 + 7) + 1;
    p3 = t.indexOf("<" + "/script>", p2);
    p4 = p3 + 9;
    
    var c = t.substring(p2, p3);
    var s = document.createElement("script");
    s.type = "text/javascript";
    s.text = c;
    document.getElementsByTagName("head")[0].appendChild(s);
    
    t = t.substring(0, p1) + t.substr(p4);
    return execJS(t);
}

function extractZip(fileName, destinazione, callback_success, callback_fail) {
    if(!callback_success)callback_success = success;
    if(!callback_fail)callback_fail = fail;
    zip.unzip(fileName, destinazione, callback_success);
}

function file_download(url,nome_file,callback_success,callback_fail){
    if(!callback_success)callback_success = success;
    if(!callback_fail)callback_fail = fail;

    var fileTransfer = new FileTransfer();
    
    var filePath = DIRECTORY.nativeURL + nome_file;
alert(217);
    if(document.getElementById('loader_progress')){
        fileTransfer.onprogress = function(progressEvent) {
            if (progressEvent.lengthComputable) {
                //document.getElementById('loader_progress').innerHTML = 'progressEvent.loaded:'+progressEvent.loaded+' progressEvent.total:'+progressEvent.total;
                loader_progress_action(progressEvent.loaded,progressEvent.total,'loader_progress_cursore');
            }else{
            }
        };
    }

    fileTransfer.download(url, filePath, 
        function(entry){
            callback_success(entry);
        },function(e){/*fail(e);*/callback_fail(e);});
}

function loader_progress_action(loaded,total){
    var percentuale = (100 * loaded) / total;
    document.getElementById('loader_progress').style.height = "1em";
    document.getElementById('loader_progress').style.visibility = "visible";
    document.getElementById('loader_progress_cursore').style.height = "0.7em";
    document.getElementById('loader_progress_cursore').style.width = (percentuale-2) + "%";
    document.getElementById('loader_progress_label').innerHTML = 'inizializzazione in corso..';
}

function file_cancella(nome_file, callback_success, callback_fail, modalita) {
    
    if(!callback_success) callback_success = function(){success();};
    if(!callback_fail) callback_fail = function(e){fail(e,"file_cancella: " + nome_file);};
    if(!modalita) modalita = 'new';
    window.resolveLocalFileSystemURL(DIRECTORY.nativeURL, function(dir) {
        dir.getFile(nome_file, {create: true, exclusive: false}, function(file) {
            file.remove(function() {
                callback_success();
            }, callback_fail);         
        });
    });
    
}

function file_leggi(nome_file,callback_success,callback_fail) {
    if(!callback_success) callback_success = function(){success();};
    if(!callback_fail) callback_fail = function(e){fail(e,"file_leggi: " + nome_file);};    
    
    window.resolveLocalFileSystemURL(DIRECTORY.nativeURL, 
        function(dir) {
            dir.getFile(nome_file, {exclusive: false }, 
                function(fileEntry) {
                    fileEntry.file(
                        function (file) {
                            var reader = new FileReader();
                            reader.onloadend = function() {
                                callback_success(this.result);
                            };
                            reader.readAsText(file);
                        }
                    );
                }, callback_fail
            );
        }, callback_fail
    );
}

function file_scrivi(nome_file, valore, callback_success, callback_fail, modalita) {
    
    if(!callback_success) callback_success = function(){success();};
    if(!callback_fail) callback_fail = function(e){fail(e,"file_scrivi: " + nome_file);};
    if(!modalita) modalita = 'new';
    window.resolveLocalFileSystemURL(DIRECTORY.nativeURL, function(dir) {
        dir.getFile(nome_file, {create: true, exclusive: false}, function(file) {
            file.createWriter(function(fileWriter) {
                if(modalita == 'append') {
                    fileWriter.seek(fileWriter.length);
                }
                fileWriter.onwriteend = callback_success;
                fileWriter.write(valore);
            }, callback_fail);         
        });
    });
    
}

function success(){
    
}
function fail(e,label){ 
    var str = JSON.stringify(e);
    if(MODALITA_DEBUG){
        if(str){
            alert(label + ": " + str);
        }
    }
}
function controlla_connessione(){
    var networkState = navigator.connection.type;
    //alert(networkState);
    //alert(Connection.NONE);
    if (networkState == Connection.NONE){
        return null;
    }else{
        return true;
    }
}
function noCache() {
    return "?ver="+new Date().getTime();
}
function javascriptErrorHandler(errorMsg, url, lineNumber){
    if(MODALITA_DEBUG){
        alert(errorMsg + " - " + url + ":" + lineNumber);
    }
    try{
    }catch(Exception){
        if(MODALITA_DEBUG){
            alert(Exception.message);
        }
    }
    return true;
}